Index: /trunk/kernel/kern/kernel_init.c
===================================================================
--- /trunk/kernel/kern/kernel_init.c	(revision 656)
+++ /trunk/kernel/kern/kernel_init.c	(revision 657)
@@ -3,5 +3,5 @@
  *
  * Authors :  Mohamed Lamine Karaoui (2015)
- *            Alain Greiner  (2016,2017,2018,2019)
+ *            Alain Greiner  (2016,2017,2018,2019,2020)
  *
  * Copyright (c) Sorbonne Universites
@@ -136,9 +136,9 @@
     "VMM_STACK",             //  3
     "VMM_MMAP",              //  4
-    "VFS_CTX",               //  5
-    "KCM_STATE",             //  6
-    "KHM_STATE",             //  7
-    "HTAB_STATE",            //  8
-
+    "KCM_STATE",             //  5
+    "KHM_STATE",             //  6
+    "HTAB_STATE",            //  7
+
+    "VFS_CTX",               //  8
     "PPM_FREE",              //  9
     "THREAD_JOIN",           // 10
@@ -172,4 +172,5 @@
     "VFS_MAIN",              // 34
     "FATFS_FAT",             // 35
+    "FBF_WINDOWS",           // 36
 };        
 
@@ -874,5 +875,5 @@
 // @ cxy     : [out] cluster identifier.
 // @ lid     : [out] core global identifier (hardware).
-// @ return 0 if success / return EINVAL if not found.
+// @ return 0 if success / return -1 if not found.
 ///////////////////////////////////////////////////////////////////////////////////////////
 static error_t __attribute__ ((noinline)) get_core_identifiers( boot_info_t * info,
@@ -898,27 +899,5 @@
         }
     }
-    return EINVAL;
-}
-
-
-
-
-
-/////////////////////////////////
-// kleenex debug function
-/////////////////////////////////
-void display_fat( uint32_t step )
-{
-    fatfs_ctx_t * fatfs_ctx = fs_context[FS_TYPE_FATFS].extend;
-    if( fatfs_ctx != NULL ) 
-    {
-        printk("\n[%s] step %d at cycle %d\n", __FUNCTION__, step, (uint32_t)hal_get_cycles() );
-        xptr_t     mapper_xp = fatfs_ctx->fat_mapper_xp;
-        mapper_display_page( mapper_xp , 0 , 128 );
-    }
-    else
-    {
-        printk("\n[%s] step %d : fatfs context not initialized\n", __FUNCTION__, step );
-    }
+    return -1;
 }
 
@@ -949,5 +928,4 @@
     xptr_t       devfs_dev_inode_xp;        // extended pointer on DEVFS dev inode    
     xptr_t       devfs_external_inode_xp;   // extended pointer on DEVFS external inode       
-    xptr_t       devfs_internal_inode_xp;   // extended pointer on DEVFS internal inode       
 
     error_t      error;
@@ -1139,5 +1117,5 @@
 #endif
 
-#if( DEBUG_KERNEL_INIT & 1 )
+#if CONFIG_INSTRUMENTATION_CHDEVS
 if( (core_lid ==  0) & (local_cxy == 0) ) 
 chdev_dir_display();
@@ -1145,8 +1123,19 @@
     
     /////////////////////////////////////////////////////////////////////////////////
-    // STEP 6 : all cores enable IPI (Inter Procesor Interrupt),
-    //          all cores unblock the idle thread, and register it in scheduler.
-    //          core[0] in cluster[0] creates the VFS root inode.
-    //          It access the boot device to initialize the file system context.
+    // STEP 6 : All cores enable IPI (Inter Procesor Interrupt),
+    //          All cores unblock the idle thread, and register it in scheduler.
+    //          The core[0] in cluster defined by the CONFIG_VFS_ROOT_CXY parameter,
+    //          access the IOC device to initialize the VFS for the FS identified
+    //          by the CONFIG_VFS_ROOT_IS_*** parameter. It does the following
+    //          actions in the VFS_ROOT cluster :
+    //          1. allocate and initialize the selected FS context,
+    //          2. create and initializes the VFS root inodes,
+    //          3. initialize the VFS context for FATFS (in fs_context[] array),
+    //          4. create the <.> and <..> dentries in VFS root directory,
+    //          5. register the VFS root inode in process_zero descriptor, 
+    //          6. allocate the DEVFS context, 
+    //          7. initialize the VFS context for DEVFS (in fs_context[] array),
+    //          8. create the <dev> and <external> inodes,
+    //          9. initialize the DEVFS context.
     /////////////////////////////////////////////////////////////////////////////////
 
@@ -1159,76 +1148,151 @@
     core->scheduler.idle = thread;
 
-    // core[O] in cluster[0] creates the VFS root
-    if( (core_lid ==  0) && (local_cxy == 0 ) ) 
+    // core[O] in VFS_ROOT cluster creates the VFS root
+    if( (core_lid ==  0) && (local_cxy == CONFIG_VFS_ROOT_CXY ) ) 
     {
-        vfs_root_inode_xp = XPTR_NULL;
-
         // Only FATFS is supported yet,
-        // other File System can be introduced here
+        // TODO other File System can be introduced below
         if( CONFIG_VFS_ROOT_IS_FATFS )
         {
-            // 1. allocate memory for FATFS context in cluster 0
-            fatfs_ctx_t * fatfs_ctx = fatfs_ctx_alloc();
-
-            if( fatfs_ctx == NULL )
+            // 1. allocate memory and initialize FATFS context in VFS_ROOT cluster
+            xptr_t  fatfs_ctx_xp = fatfs_ctx_alloc( CONFIG_VFS_ROOT_CXY );
+
+            if( fatfs_ctx_xp == XPTR_NULL )
             {
-                printk("\n[PANIC] in %s : cannot create FATFS context in cluster 0\n",
-                __FUNCTION__ );
+                printk("\n[PANIC] in %s : cannot allocate FATFS context in cluster %x\n",
+                __FUNCTION__ , CONFIG_VFS_ROOT_CXY );
                 hal_core_sleep();
             }
 
-            // 2. access boot device to initialize FATFS context
-            fatfs_ctx_init( fatfs_ctx );
-
-            // 3. get various informations from FATFS context
-            uint32_t root_dir_cluster = fatfs_ctx->root_dir_cluster;
-            uint32_t cluster_size     = fatfs_ctx->bytes_per_sector * 
-                                        fatfs_ctx->sectors_per_cluster;
-            uint32_t total_clusters   = fatfs_ctx->fat_sectors_count << 7;
- 
-            // 4. create VFS root inode in cluster 0
-            error = vfs_inode_create( FS_TYPE_FATFS,                       // fs_type
-                                      0,                                   // attr
-                                      0,                                   // rights
-                                      0,                                   // uid
-                                      0,                                   // gid
-                                      &vfs_root_inode_xp );                // return
+            // initialise FATFS context in VFS_ROOT cluster from IOC device (boot_record)
+            error = fatfs_ctx_init( fatfs_ctx_xp );
+
             if( error )
             {
-                printk("\n[PANIC] in %s : cannot create VFS root inode in cluster 0\n",
-                __FUNCTION__ );
+                printk("\n[PANIC] in %s : cannot initialize FATFS context in cluster %x\n",
+                __FUNCTION__ , CONFIG_VFS_ROOT_CXY );
                 hal_core_sleep();
             }
 
-            // 5. update FATFS root inode "type" and "extend" fields  
-            cxy_t         vfs_root_cxy = GET_CXY( vfs_root_inode_xp );
-            vfs_inode_t * vfs_root_ptr = GET_PTR( vfs_root_inode_xp );
-            hal_remote_s32( XPTR( vfs_root_cxy , &vfs_root_ptr->type ), INODE_TYPE_DIR );
-            hal_remote_spt( XPTR( vfs_root_cxy , &vfs_root_ptr->extend ), 
+#if( DEBUG_KERNEL_INIT & 1 )
+printk("\n[%s] initialized FATFS context in cluster %x\n",
+__FUNCTION__, CONFIG_VFS_ROOT_CXY );
+#endif
+    
+            // get various informations from FATFS context
+            fatfs_ctx_t * fatfs_ctx_ptr = GET_PTR( fatfs_ctx_xp );
+
+            uint32_t root_dir_cluster    = hal_remote_l32( XPTR( CONFIG_VFS_ROOT_CXY,
+                                           &fatfs_ctx_ptr->root_dir_cluster ) );
+
+            uint32_t bytes_per_sector    = hal_remote_l32( XPTR( CONFIG_VFS_ROOT_CXY,
+                                           &fatfs_ctx_ptr->bytes_per_sector ) );
+ 
+            uint32_t sectors_per_cluster = hal_remote_l32( XPTR( CONFIG_VFS_ROOT_CXY,
+                                           &fatfs_ctx_ptr->sectors_per_cluster ) );
+ 
+            uint32_t cluster_size        = bytes_per_sector * sectors_per_cluster;
+ 
+            uint32_t fat_sectors_count   = hal_remote_l32( XPTR( CONFIG_VFS_ROOT_CXY,
+                                           &fatfs_ctx_ptr->fat_sectors_count ) ) << 7;
+
+            uint32_t total_clusters      = fat_sectors_count << 7;
+ 
+            // 2. create VFS root inode in VFS_ROOT cluster
+            // TODO define attr, rights, uid, gid
+            error = vfs_inode_create( CONFIG_VFS_ROOT_CXY,          // target cluster
+                                      FS_TYPE_FATFS,                // fs_type
+                                      0,                            // attr
+                                      0,                            // rights
+                                      0,                            // uid
+                                      0,                            // gid
+                                      &vfs_root_inode_xp );         // return
+            if( error )
+            {
+                printk("\n[PANIC] in %s : cannot create VFS root inode in cluster %x\n",
+                __FUNCTION__ , CONFIG_VFS_ROOT_CXY );
+                hal_core_sleep();
+            }
+
+#if( DEBUG_KERNEL_INIT & 1 )
+vfs_inode_t * root_inode = GET_PTR( vfs_root_inode_xp );
+printk("\n[%s] created </> root inode %x in cluster %x / ctx %x\n",
+__FUNCTION__, root_inode, CONFIG_VFS_ROOT_CXY, root_inode->ctx );
+#endif
+    
+            // update FATFS root inode "type" and "extend" fields  
+            vfs_inode_t * vfs_root_inode_ptr = GET_PTR( vfs_root_inode_xp );
+
+            hal_remote_s32( XPTR( CONFIG_VFS_ROOT_CXY , &vfs_root_inode_ptr->type ),
+                            INODE_TYPE_DIR );
+
+            hal_remote_spt( XPTR( CONFIG_VFS_ROOT_CXY , &vfs_root_inode_ptr->extend ), 
                             (void*)(intptr_t)root_dir_cluster );
 
-            // 6. initialize the generic VFS context for FATFS 
-            vfs_ctx_init( FS_TYPE_FATFS,                               // fs type
-                          0,                                           // attributes: unused 
-	                      total_clusters,                              // number of clusters
-	                      cluster_size,                                // bytes
-	                      vfs_root_inode_xp,                           // VFS root
-                          fatfs_ctx );                                 // extend
+            // 3. initialize the VFS context for FATFS in VFS_ROOT cluster
+            vfs_ctx_init( CONFIG_VFS_ROOT_CXY,                      // target cluster
+                          FS_TYPE_FATFS,                            // fs type
+	                      total_clusters,                           // number of clusters
+	                      cluster_size,                             // bytes
+	                      vfs_root_inode_xp,                        // VFS root
+                          fatfs_ctx_ptr );                          // extend
+
+#if( DEBUG_KERNEL_INIT & 1 )
+vfs_ctx_t * vfs_for_fatfs_ctx =  &fs_context[FS_TYPE_FATFS];
+printk("\n[%s] initialized VFS_for_FATFS context in cluster %x / ctx %x / fs_type %d\n",
+__FUNCTION__, CONFIG_VFS_ROOT_CXY, vfs_for_fatfs_ctx, vfs_for_fatfs_ctx->type );
+#endif
         }
         else
         {
-            printk("\n[PANIC] in %s : unsupported VFS type in cluster 0\n",
-            __FUNCTION__ );
+            printk("\n[PANIC] in %s : unsupported VFS type in cluster %x\n",
+            __FUNCTION__ , CONFIG_VFS_ROOT_CXY );
             hal_core_sleep();
         }
 
-        // create the <.> and <..> dentries in VFS root directory
+        // 4. create the <.> and <..> dentries in VFS root directory
         // the VFS root parent inode is the VFS root inode itself 
         vfs_add_special_dentries( vfs_root_inode_xp,
                                   vfs_root_inode_xp );
 
-        // register VFS root inode in process_zero descriptor of cluster 0
-        process_zero.vfs_root_xp = vfs_root_inode_xp;
-        process_zero.cwd_xp      = vfs_root_inode_xp;
+        // 5. register VFS root inode in target cluster process_zero descriptor 
+        hal_remote_s64( XPTR( CONFIG_VFS_ROOT_CXY , &process_zero.vfs_root_xp ),
+                        vfs_root_inode_xp );
+        hal_remote_s64( XPTR( CONFIG_VFS_ROOT_CXY , &process_zero.cwd_xp ),
+                        vfs_root_inode_xp );
+
+        // 6. allocate memory for DEVFS context in VFS_ROOT cluster
+        xptr_t devfs_ctx_xp = devfs_ctx_alloc( CONFIG_VFS_ROOT_CXY );
+
+        if( devfs_ctx_xp == XPTR_NULL )
+        {
+            printk("\n[PANIC] in %s : cannot create DEVFS context in cluster %x\n",
+            __FUNCTION__ , CONFIG_VFS_ROOT_CXY );
+            hal_core_sleep();
+        }
+
+        // 7. initialize the VFS context for DEVFS in VFS_ROOT cluster 
+        vfs_ctx_init( CONFIG_VFS_ROOT_CXY,                          // target cluster
+                      FS_TYPE_DEVFS,                                // fs type
+	                  0,                                            // total_clusters: unused
+	                  0,                                            // cluster_size: unused 
+	                  vfs_root_inode_xp,                            // VFS root
+                      GET_PTR( devfs_ctx_xp ) );                    // extend
+
+#if( DEBUG_KERNEL_INIT & 1 )
+vfs_ctx_t * vfs_for_devfs_ctx =  &fs_context[FS_TYPE_DEVFS];
+printk("\n[%s] initialized VFS_for_DEVFS context in cluster %x / ctx %x / fs_type %d\n",
+__FUNCTION__, CONFIG_VFS_ROOT_CXY, vfs_for_devfs_ctx, vfs_for_devfs_ctx->type );
+#endif
+
+        // 8. create "dev" and "external" inodes (directories)
+        devfs_global_init( vfs_root_inode_xp,
+                           &devfs_dev_inode_xp,
+                           &devfs_external_inode_xp );
+
+        // 9. initializes DEVFS context in VFS_ROOT cluster
+        devfs_ctx_init( devfs_ctx_xp,
+                        devfs_dev_inode_xp,
+                        devfs_external_inode_xp );
     }
 
@@ -1240,28 +1304,31 @@
 
 #if DEBUG_KERNEL_INIT
-if( (core_lid ==  0) & (local_cxy == 0) ) 
-printk("\n[%s] exit barrier 6 : VFS root (%x,%x) in cluster 0 / cycle %d\n",
-__FUNCTION__, GET_CXY(process_zero.vfs_root_xp),
-GET_PTR(process_zero.vfs_root_xp), (uint32_t)hal_get_cycles() );
-#endif
-
-    /////////////////////////////////////////////////////////////////////////////////
-    // STEP 7 : In all other clusters than cluster[0], the core[0] allocates memory
-    //          for the selected FS context, and initialise the local FS context and 
-    //          the local VFS context from values stored in cluster 0. 
-    //          They get the VFS root inode extended pointer from cluster 0.
-    /////////////////////////////////////////////////////////////////////////////////
-
-    if( (core_lid ==  0) && (local_cxy != 0) ) 
+if( (core_lid ==  0) & (local_cxy == CONFIG_VFS_ROOT_CXY) ) 
+printk("\n[%s] exit barrier 6 : VFS root inode (%x) created in cluster (%x) / cycle %d\n",
+__FUNCTION__, GET_CXY(vfs_root_inode_xp), 
+GET_PTR(vfs_root_inode_xp), (uint32_t)hal_get_cycles() );
+#endif
+
+    /////////////////////////////////////////////////////////////////////////////////
+    // STEP 7 : In all clusters other than the VFS_ROOT cluster, the core[0] makes
+    //          the following local actions to complete the VFS initialisation :
+    //          1. allocate a local context for the selected FS extension,
+    //          2. copy FS context from VFS_ROOT cluster to local cluster,
+    //          3. copy VFS_for_FATFS context from VFS_ROOT cluster to local cluster, 
+    //          4. allocate a local context for the DEVFS extension, 
+    //          5. copy DEVFS context from VFS_ROOT cluster to local cluster,
+    //          6. update the local "root_inode_xp" field in process_zero.
+    /////////////////////////////////////////////////////////////////////////////////
+
+    if( (core_lid ==  0) && (local_cxy != CONFIG_VFS_ROOT_CXY) ) 
     {
-        // File System must be FATFS in this implementation,
-        // but other File System can be introduced here
+        // only FATFS is supported yet
+        // TODO other File System can be introduced below
         if( CONFIG_VFS_ROOT_IS_FATFS )
         {
-            // 1. allocate memory for local FATFS context
-            fatfs_ctx_t * local_fatfs_ctx = fatfs_ctx_alloc();
-
-            // check memory
-            if( local_fatfs_ctx == NULL )
+            // 1. allocate a local FATFS context extension
+            xptr_t local_fatfs_ctx_xp = fatfs_ctx_alloc( local_cxy );
+
+            if( local_fatfs_ctx_xp == XPTR_NULL )
             {
                 printk("\n[PANIC] in %s : cannot create FATFS context in cluster %x\n",
@@ -1270,33 +1337,75 @@
             }
 
-            // 2. get local pointer on VFS context for FATFS
-            vfs_ctx_t   * vfs_ctx = &fs_context[FS_TYPE_FATFS];
-
-            // 3. get local pointer on FATFS context in cluster 0 
-            fatfs_ctx_t * remote_fatfs_ctx = hal_remote_lpt( XPTR( 0 , &vfs_ctx->extend ) );
-
-            // 4. copy FATFS context from cluster 0 to local cluster
-            hal_remote_memcpy( XPTR( local_cxy , local_fatfs_ctx ), 
-                               XPTR( 0 ,         remote_fatfs_ctx ), sizeof(fatfs_ctx_t) );
-
-            // 5. copy VFS context from cluster 0 to local cluster
-            hal_remote_memcpy( XPTR( local_cxy , vfs_ctx ), 
-                               XPTR( 0 ,         vfs_ctx ), sizeof(vfs_ctx_t) );
-
-            // 6. update extend field in local copy of VFS context
-            vfs_ctx->extend = local_fatfs_ctx;
-
-            if( ((fatfs_ctx_t *)vfs_ctx->extend)->sectors_per_cluster != 8 )
-            {
-                printk("\n[PANIC] in %s : illegal FATFS context in cluster %x\n",
-                __FUNCTION__ , local_cxy );
-                hal_core_sleep();
-            }
-        }
-
-        // get extended pointer on VFS root inode from cluster 0
-        vfs_root_inode_xp = hal_remote_l64( XPTR( 0 , &process_zero.vfs_root_xp ) );
-
-        // update local process_zero descriptor
+            // get local pointer on VFS_for_FATFS context (same in all clusters) 
+            vfs_ctx_t * vfs_fat_ctx_ptr = &fs_context[FS_TYPE_FATFS];
+
+            // build extended pointer on VFS_for_FATFS "extend" field in VFS_ROOT cluster
+            xptr_t fatfs_extend_xp = XPTR( CONFIG_VFS_ROOT_CXY , &vfs_fat_ctx_ptr->extend );
+
+            // get local pointer on FATFS context in VFS_ROOT cluster 
+            fatfs_ctx_t * remote_fatfs_ctx_ptr = hal_remote_lpt( fatfs_extend_xp );
+
+            // build extended pointer on FATFS context in VFS_ROOT cluster
+            xptr_t remote_fatfs_ctx_xp = XPTR( CONFIG_VFS_ROOT_CXY , remote_fatfs_ctx_ptr );
+
+            // 2. copy FATFS context from VFS_ROOT cluster to local cluster
+            hal_remote_memcpy( local_fatfs_ctx_xp,
+                               remote_fatfs_ctx_xp,
+                               sizeof(fatfs_ctx_t) );
+
+            // build extended pointer on remote VFS_for_FATFS context
+            xptr_t remote_vfs_ctx_xp = XPTR( CONFIG_VFS_ROOT_CXY , vfs_fat_ctx_ptr );
+
+            // build extended pointer on local VFS_for_FATFS context
+            xptr_t local_vfs_ctx_xp = XPTR( local_cxy , vfs_fat_ctx_ptr );
+ 
+            // 3. copy VFS_for_FATFS context from VFS_ROOT cluster to local cluster
+            hal_remote_memcpy( local_vfs_ctx_xp,
+                               remote_vfs_ctx_xp,
+                               sizeof(vfs_ctx_t) );
+
+            // update "extend" field in local VFS_for_FATFS context
+            vfs_fat_ctx_ptr->extend = GET_PTR( local_fatfs_ctx_xp );
+
+// check local FATFS and VFS context copies
+assert( (((fatfs_ctx_t *)vfs_fat_ctx_ptr->extend)->sectors_per_cluster == 8),
+"illegal FATFS context in cluster %x\n", local_cxy );
+
+        }
+        else
+        {
+            printk("\n[PANIC] in %s : unsupported VFS type in cluster %x\n",
+            __FUNCTION__ , local_cxy );
+            hal_core_sleep();
+        }
+
+        // 4. allocate a local DEVFS context extension, 
+        xptr_t local_devfs_ctx_xp = devfs_ctx_alloc( local_cxy );
+
+        // get local pointer on VFS_for_DEVFS context (same in all clusters) 
+        vfs_ctx_t * vfs_dev_ctx_ptr = &fs_context[FS_TYPE_DEVFS];
+
+        // build extended pointer on VFS_for_DEVFS extend field in VFS_ROOT cluster
+        xptr_t remote_extend_xp = XPTR( CONFIG_VFS_ROOT_CXY , &vfs_dev_ctx_ptr->extend );
+
+        // get local pointer on DEVFS context in VFS_ROOT cluster 
+        devfs_ctx_t * remote_devfs_ctx_ptr = hal_remote_lpt( remote_extend_xp );
+
+        // build extended pointer on FATFS context in VFS_ROOT cluster
+        xptr_t remote_devfs_ctx_xp = XPTR( CONFIG_VFS_ROOT_CXY , remote_devfs_ctx_ptr );
+
+        // 5. copy DEVFS context from VFS_ROOT cluster to local cluster
+        hal_remote_memcpy( local_devfs_ctx_xp,
+                           remote_devfs_ctx_xp,
+                           sizeof(devfs_ctx_t) );
+
+        // update "extend" field in local VFS_for_DEVFS context
+        vfs_dev_ctx_ptr->extend = GET_PTR( local_devfs_ctx_xp );
+
+        // get extended pointer on VFS root inode from VFS_ROOT cluster
+        vfs_root_inode_xp = hal_remote_l64( XPTR( CONFIG_VFS_ROOT_CXY,
+                                                  &process_zero.vfs_root_xp ) );
+
+        // 6. update local process_zero descriptor
         process_zero.vfs_root_xp = vfs_root_inode_xp;
         process_zero.cwd_xp      = vfs_root_inode_xp;
@@ -1310,46 +1419,24 @@
 
 #if DEBUG_KERNEL_INIT
-if( (core_lid ==  0) & (local_cxy == 1) ) 
-printk("\n[%s] exit barrier 7 : VFS root (%x,%x) in cluster 1 / cycle %d\n",
-__FUNCTION__, GET_CXY(process_zero.vfs_root_xp),
-GET_PTR(process_zero.vfs_root_xp), (uint32_t)hal_get_cycles() );
-#endif
-
-    /////////////////////////////////////////////////////////////////////////////////
-    // STEP 8 : core[0] in cluster 0 makes the global DEVFS initialisation:
-    //          It initializes the DEVFS context, and creates the DEVFS
-    //          "dev" and "external" inodes in cluster 0.
-    /////////////////////////////////////////////////////////////////////////////////
-
-    if( (core_lid ==  0) && (local_cxy == 0) ) 
+if( (core_lid ==  0) & (local_cxy == 0) ) 
+printk("\n[%s] exit barrier 7 : VFS & DEVFS contexts replicated in all clusters / cycle %d\n",
+__FUNCTION__ , (uint32_t)hal_get_cycles() );
+#endif
+
+    /////////////////////////////////////////////////////////////////////////////////
+    // STEP 8 : In all clusters in parallel, core[0] completes DEVFS initialization.
+    //          Each core[0] creates the local DEVFS "internal" directory,
+    //          and creates the pseudo-files for chdevs placed in local cluster.
+    /////////////////////////////////////////////////////////////////////////////////
+
+    if( core_lid == 0 )
     {
-        // 1. allocate memory for DEVFS context extension in cluster 0
-        devfs_ctx_t * devfs_ctx = devfs_ctx_alloc();
-
-        if( devfs_ctx == NULL )
-        {
-            printk("\n[PANIC] in %s : cannot create DEVFS context in cluster 0\n",
-            __FUNCTION__ , local_cxy );
-            hal_core_sleep();
-        }
-
-        // 2. initialize the DEVFS entry in the vfs_context[] array 
-        vfs_ctx_init( FS_TYPE_DEVFS,                                // fs type
-                      0,                                            // attributes: unused
-	                  0,                                            // total_clusters: unused
-	                  0,                                            // cluster_size: unused 
-	                  vfs_root_inode_xp,                            // VFS root
-                      devfs_ctx );                                  // extend
-
-        // 3. create "dev" and "external" inodes (directories)
-        devfs_global_init( process_zero.vfs_root_xp,
-                           &devfs_dev_inode_xp,
-                           &devfs_external_inode_xp );
-
-        // 4. initializes DEVFS context extension
-        devfs_ctx_init( devfs_ctx,
-                        devfs_dev_inode_xp,
-                        devfs_external_inode_xp );
-    }    
+        // get local pointer on local DEVFS context
+        devfs_ctx_t * ctx = fs_context[FS_TYPE_DEVFS].extend;
+
+        // populate DEVFS in all clusters
+        devfs_local_init( ctx->dev_inode_xp,
+                          ctx->external_inode_xp );
+    }
 
     /////////////////////////////////////////////////////////////////////////////////
@@ -1361,41 +1448,5 @@
 #if DEBUG_KERNEL_INIT
 if( (core_lid ==  0) & (local_cxy == 0) ) 
-printk("\n[%s] exit barrier 8 : DEVFS root initialized in cluster 0 / cycle %d\n",
-__FUNCTION__, (uint32_t)hal_get_cycles() );
-#endif
-
-    /////////////////////////////////////////////////////////////////////////////////
-    // STEP 9 : In all clusters in parallel, core[0] completes DEVFS initialization.
-    //          Each core[0] get the "dev" and "external" extended pointers from
-    //          values stored in cluster(0), creates the DEVFS "internal" directory, 
-    //          and creates the pseudo-files for all chdevs in local cluster.
-    /////////////////////////////////////////////////////////////////////////////////
-
-    if( core_lid == 0 )
-    {
-        // get extended pointer on "extend" field of VFS context for DEVFS in cluster 0
-        xptr_t  extend_xp = XPTR( 0 , &fs_context[FS_TYPE_DEVFS].extend );
-
-        // get pointer on DEVFS context in cluster 0
-        devfs_ctx_t * devfs_ctx = hal_remote_lpt( extend_xp );
-        
-        devfs_dev_inode_xp      = hal_remote_l64( XPTR( 0 , &devfs_ctx->dev_inode_xp ) );
-        devfs_external_inode_xp = hal_remote_l64( XPTR( 0 , &devfs_ctx->external_inode_xp ) );
-
-        // populate DEVFS in all clusters
-        devfs_local_init( devfs_dev_inode_xp,
-                          devfs_external_inode_xp,
-                          &devfs_internal_inode_xp );
-    }
-
-    /////////////////////////////////////////////////////////////////////////////////
-    if( core_lid == 0 ) xbarrier_wait( XPTR( 0 , &global_barrier ), 
-                                        (info->x_size * info->y_size) );
-    barrier_wait( &local_barrier , info->cores_nr );
-    /////////////////////////////////////////////////////////////////////////////////
-
-#if DEBUG_KERNEL_INIT
-if( (core_lid ==  0) & (local_cxy == 0) ) 
-printk("\n[%s] exit barrier 9 : DEVFS initialized in cluster 0 / cycle %d\n",
+printk("\n[%s] exit barrier 8 : DEVFS initialized in all clusters / cycle %d\n",
 __FUNCTION__, (uint32_t)hal_get_cycles() );
 #endif
@@ -1407,7 +1458,7 @@
 
     /////////////////////////////////////////////////////////////////////////////////
-    // STEP 10 : core[0] in cluster 0 creates the first user process (process_init).
-    //           This include the first user process VMM (GPT and VSL) creation.
-    //           Finally, it prints the ALMOS-MKH banner.
+    // STEP 9 : core[0] in cluster 0 creates the first user process (process_init).
+    //          This include the process VMM (GPT and VSL) creation.
+    //          Finally, it prints the ALMOS-MKH banner.
     /////////////////////////////////////////////////////////////////////////////////
 
@@ -1419,5 +1470,5 @@
 #if DEBUG_KERNEL_INIT
 if( (core_lid ==  0) & (local_cxy == 0) ) 
-printk("\n[%s] exit barrier 10 : process_init created in cluster 0 / cycle %d\n",
+printk("\n[%s] exit barrier 9 : process_init created in cluster 0 / cycle %d\n",
 __FUNCTION__, (uint32_t)hal_get_cycles() );
 #endif
Index: /trunk/kernel/kern/printk.h
===================================================================
--- /trunk/kernel/kern/printk.h	(revision 656)
+++ /trunk/kernel/kern/printk.h	(revision 657)
@@ -2,5 +2,5 @@
  * printk.h - Kernel Log & debug messages API definition.
  *
- * authors  Alain Greiner (2016,2017,2018)
+ * authors  Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -123,5 +123,5 @@
 
 /**********************************************************************************
- * This function displays a non-formated message on TXT0 terminal.
+ * This debug function displays a non-formated message on TXT0 terminal.
  * This function is actually used to debug the assembly level kernel functions.
  **********************************************************************************
@@ -131,5 +131,5 @@
 
 /**********************************************************************************
- * This function displays a 32 bits value in hexadecimal on TXT0 terminal.
+ * This debug function displays a 32 bits value in hexadecimal on TXT0 terminal.
  * This function is actually used to debug the assembly level kernel functions.
  **********************************************************************************
@@ -139,5 +139,5 @@
 
 /**********************************************************************************
- * This function displays a 32 bits signed value in decimal on TXT0 terminal.
+ * This debug function displays a 32 bits signed value in decimal on TXT0 terminal.
  * This function is actually used to debug the assembly level kernel functions.
  **********************************************************************************
@@ -147,5 +147,5 @@
 
 /**********************************************************************************
- * This function displays a 64 bits value in hexadecimal on TXT0 terminal.
+ * This debug function displays a 64 bits value in hexadecimal on TXT0 terminal.
  * This function is actually used to debug the assembly level kernel functions.
  **********************************************************************************
@@ -158,5 +158,5 @@
  * array of bytes defined by <buffer> and <size> arguments (16 bytes per line).
  * The <string> argument is displayed before the buffer content.
- * The line format is an address folowed by 16 (hexa) bytes.
+ * The line format is an address followed by 16 (hexa) bytes.
  **********************************************************************************
  * @ string   : buffer name or identifier.
